unit plazaUnit5;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ComCtrls, StdCtrls, ExtCtrls, Buttons;

type
  TForm5 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    StringGrid1: TStringGrid;
    Button1: TButton;
    LabeledEdit1: TLabeledEdit;
    Button2: TButton;
    StringGrid2: TStringGrid;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    Button3: TButton;
    Button4: TButton;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    LabeledEdit6: TLabeledEdit;
    LabeledEdit7: TLabeledEdit;
    LabeledEdit8: TLabeledEdit;
    LabeledEdit9: TLabeledEdit;
    LabeledEdit10: TLabeledEdit;
    LabeledEdit11: TLabeledEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure FormCreate(Sender: TObject);     // ustawia naglowki StrinGridow
    procedure Button1Click(Sender: TObject);  // dodaje nowego obserwatora
    procedure Button2Click(Sender: TObject);   // usuwa obserwatorw
    procedure FormShow(Sender: TObject);      // laduje dane do okienka
    procedure Button3Click(Sender: TObject);  // dodaje lodz
    procedure Button4Click(Sender: TObject);  // usuwa lodzie
    procedure CheckEdit(Sender: TObject);     // do wszystkich wolnych editw: sprawdza poprawnosc zawartosci
    procedure BitBtn1Click(Sender: TObject);  // aktualizuje dane i zamyka
  private
  public
    { Public declarations }
  end;

var
  Form5: TForm5;

implementation

uses plazaUnit2, plazaUnit3, wymianadanych;

{$R *.dfm}

procedure TForm5.FormCreate(Sender: TObject);
begin
  StringGrid1.Cells[0,0]:='X (dm)';
  StringGrid1.Cells[1,0]:='Y (dm)';
  stringGrid1.Cells[2,0]:='Zasig (dm)';
  StringGrid2.Cells[0,0]:='X (dm)';
  StringGrid2.Cells[1,0]:='Y (dm)';
  stringGrid2.Cells[2,0]:='X-patrol';
  StringGrid2.Cells[3,0]:='Y-patrol';
  StringGrid2.Cells[4,0]:='Prdko (dm/s)';
  stringGrid2.Cells[5,0]:='Zasig (dm)';
end;

procedure TForm5.Button1Click(Sender: TObject);
begin
  try
    strtoint(LabeledEdit1.Text)
  except
    LabeledEdit1.SetFocus;
    showmessage('"'+LabeledEdit1.Text+'" nie jest poprawn wartoci.');
    Exit
  end;
  Form2.Adding:=true;
  Form2.added:=false;
  Form2.what:=1;
  Form3.Showmodal;
  Form2.showmodal;
  if Form2.Added then
    begin
      Form2.Adding:=false;
      StringGrid1.RowCount:=StringGrid1.RowCount+1;
      StringGrid1.Rows[StringGrid1.RowCount-1].Text:='';
      StringGrid1.Cells[0,StringGrid1.RowCount-2]:=inttostr(Form2.qx);
      StringGrid1.Cells[1,StringGrid1.RowCount-2]:=inttostr(Form2.qy);
      StringGrid1.Cells[2,StringGrid1.RowCount-2]:=LabeledEdit1.Text;
      SetLength(obs,Length(obs)+1);
      obs[Length(obs)-1]:=TObserwator.Create;
      obs[Length(obs)-1].x:=Form2.qx;
      obs[Length(obs)-1].y:=Form2.qy;
      obs[Length(obs)-1].zasieg:=strtoint(LabeledEdit1.Text);
    end;
end;

procedure TForm5.Button2Click(Sender: TObject);
var start,stop : integer;
    i : integer;
begin
  start:=StringGrid1.Selection.Top;
  stop:=StringGrid1.Selection.Bottom;
  if stop=StringGrid1.RowCount-1 then dec(stop);
  if start=0 then inc(start);
  if start<=stop then
    begin
      for i:=stop+1 to StringGrid1.RowCount-1 do
        StringGrid1.Rows[i+start-stop-1].Text:=StringGrid1.Rows[i].Text;
      StringGrid1.RowCount:=StringGrid1.RowCount+start-stop-1;
      dec(start);dec(stop);
      for i:=start to stop do obs[i].Destroy;
      for i:=stop+1 to Length(obs)-1 do
        obs[i+start-stop-1]:=obs[i];
      SetLength(obs,Length(obs)+start-stop-1)
    end;
end;

procedure TForm5.FormShow(Sender: TObject);
var i : integer;
begin
  Stringgrid1.RowCount:=Length(obs)+2;
  for i:=1 to Length(obs) do
    begin
      StringGrid1.Cells[0,i]:=inttostr(obs[i-1].x);
      StringGrid1.Cells[1,i]:=inttostr(obs[i-1].y);
      StringGrid1.Cells[2,i]:=inttostr(obs[i-1].zasieg);
    end;
  StringGrid1.Rows[Stringgrid1.RowCount-1].Text:='';
  Stringgrid2.RowCount:=Length(lod)+2;
  for i:=1 to Length(lod) do
    begin
      StringGrid2.Cells[0,i]:=inttostr(lod[i-1].srcx);
      StringGrid2.Cells[1,i]:=inttostr(lod[i-1].srcy);
      StringGrid2.Cells[2,i]:=inttostr(lod[i-1].destx);
      StringGrid2.Cells[3,i]:=inttostr(lod[i-1].desty);
      StringGrid2.Cells[4,i]:=inttostr(lod[i-1].predkosc);
      StringGrid2.Cells[5,i]:=inttostr(lod[i-1].zasieg);
    end;
  StringGrid2.Rows[Stringgrid2.RowCount-1].Text:='';
  LabeledEdit4.Text:=inttostr(ludzie.predkosc);
  LabeledEdit5.Text:=inttostr(ludzie.zasieg);
  LabeledEdit6.Text:=inttostr(ludzie.czestosc);
  LabeledEdit7.Text:=inttostr(ludzie.maxpop);
  LabeledEdit8.Text:=inttostr(rekiny.czestosc);
  LabeledEdit9.Text:=inttostr(rekiny.maxpop);
  LabeledEdit10.Text:=inttostr(rekiny.predkosc);
  LabeledEdit11.Text:=inttostr(rekiny.zasieg);
end;

procedure TForm5.Button3Click(Sender: TObject);
begin
  try
    strtoint(LabeledEdit2.Text)
  except
    LabeledEdit2.SetFocus;
    showmessage('"'+LabeledEdit2.Text+'" nie jest poprawn wartoci.');
    Exit
  end;
  try
    strtoint(LabeledEdit3.Text)
  except
    LabeledEdit3.SetFocus;
    showmessage('"'+LabeledEdit3.Text+'" nie jest poprawn wartoci.');
    Exit
  end;
  Form2.Adding:=true;
  Form2.added:=false;
  Form2.what:=2;
  Form3.Showmodal;
  Form2.showmodal;
  if Form2.Added then
    begin
      SetLength(lod,Length(lod)+1);
      lod[Length(lod)-1]:=TLodz.Create;
      StringGrid2.RowCount:=StringGrid2.RowCount+1;
      StringGrid2.Rows[StringGrid1.RowCount-1].Text:='';
      StringGrid2.Cells[0,StringGrid2.RowCount-2]:=inttostr(Form2.qx);
      StringGrid2.Cells[1,StringGrid2.RowCount-2]:=inttostr(Form2.qy);
      lod[Length(lod)-1].x:=Form2.qx;
      lod[Length(lod)-1].y:=Form2.qy;
      lod[Length(lod)-1].srcx:=Form2.qx;
      lod[Length(lod)-1].srcy:=Form2.qy;
      lod[Length(lod)-1].dir:=true;
      Application.ProcessMessages;
      Form3.ShowModal;
      Form2.ShowModal;
      StringGrid2.Cells[2,StringGrid2.RowCount-2]:=inttostr(Form2.qx);
      StringGrid2.Cells[3,StringGrid2.RowCount-2]:=inttostr(Form2.qy);
      StringGrid2.Cells[4,StringGrid2.RowCount-2]:=LabeledEdit2.Text;
      StringGrid2.Cells[5,StringGrid2.RowCount-2]:=LabeledEdit3.Text;
      Form2.Adding:=false;
      lod[Length(lod)-1].destx:=Form2.qx;
      lod[Length(lod)-1].desty:=Form2.qy;
      lod[Length(lod)-1].predkosc:=strtoint(LabeledEdit2.Text);
      lod[Length(lod)-1].zasieg:=strtoint(LabeledEdit3.Text);
    end;
end;

procedure TForm5.Button4Click(Sender: TObject);
var start,stop : integer;
    i : integer;
begin
  start:=StringGrid2.Selection.Top;
  stop:=StringGrid2.Selection.Bottom;
  if stop=StringGrid2.RowCount-1 then dec(stop);
  if start=0 then inc(start);
  if start<=stop then
    begin
      for i:=stop+1 to StringGrid2.RowCount-1 do
        StringGrid2.Rows[i+start-stop-1].Text:=StringGrid2.Rows[i].Text;
      StringGrid2.RowCount:=StringGrid2.RowCount+start-stop-1;
      dec(start);dec(stop);
      for i:=start to stop do lod[i].Destroy;
      for i:=stop+1 to Length(lod)-1 do
        lod[i+start-stop-1]:=lod[i];
      SetLength(lod,Length(lod)+start-stop-1)
    end;
end;

procedure TForm5.CheckEdit(Sender: TObject);
begin
  try
    strtoint((Sender as TLabeledEdit).Text)
  except
    PageControl1.ActivePage:=((Sender as TLabeledEdit).Parent as TTabSheet);
    (Sender as TLabeledEdit).SetFocus;
    showmessage('"'+(Sender as TLabeledEdit).Text+'" nie jest prawidow wartoci.');
  end
end;

procedure TForm5.BitBtn1Click(Sender: TObject);
begin
  ludzie.predkosc:=strtoint(LabeledEdit4.Text);
  ludzie.zasieg:=strtoint(LabeledEdit5.Text);
  ludzie.czestosc:=strtoint(LabeledEdit6.Text);
  ludzie.maxpop:=strtoint(LabeledEdit7.Text);
  rekiny.czestosc:=strtoint(LabeledEdit8.Text);
  rekiny.maxpop:=strtoint(LabeledEdit9.Text);
  rekiny.predkosc:=strtoint(LabeledEdit10.Text);
  rekiny.zasieg:=strtoint(LabeledEdit11.Text);
  Close;
end;

end.
