unit plazaUnit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TForm3 = class(TForm)
    Image1: TImage;
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);       // gdy klikasz, by zmienic zasieg duzej mapy...
  private
    { Private declarations }
  public
    procedure ActualizeWnd;  // aktualizuje zawartosc okienka
  end;

var
  Form3: TForm3;

implementation

uses wymianadanych, Types, plazaUnit2;

{$R *.dfm}

{ TForm3 }

procedure TForm3.ActualizeWnd;
var image : TImage;
    rect : TRect;
    p : TRect;
    i : integer;
begin
  image:=TImage.Create(self);
  image.Width:=ClientWidth;
  image.Height:=ClientHeight;
  image.Canvas.CopyRect(GetClientRect,MiniMap.Bitmap.Canvas,GetClientRect);
  image.Canvas.Brush.Style:=bsClear;
  rect.Left:=px div 5;
  rect.Top:=py div 5;
  rect.Right:=rect.Left+Form2.ClientWidth div 5;
  rect.Bottom:=rect.Top+Form2.ClientHeight div 5;
  image.Canvas.Pen.Color:=clBlack;
  for i:=0 to Length(obs)-1 do
    begin
      image.Canvas.Pixels[obs[i].x div 5,obs[i].y div 5]:=clBlack;
      image.Canvas.Pixels[obs[i].x div 5 - 1,obs[i].y div 5 - 1]:=clBlack;
      image.Canvas.Pixels[obs[i].x div 5 - 1,obs[i].y div 5 + 1]:=clBlack;
      image.Canvas.Pixels[obs[i].x div 5 + 1,obs[i].y div 5 - 1]:=clBlack;
      image.Canvas.Pixels[obs[i].x div 5 + 1,obs[i].y div 5 + 1]:=clBlack;
      image.Canvas.Ellipse(
        (obs[i].x - obs[i].zasieg) div 5,
        (obs[i].y - obs[i].zasieg) div 5,
        (obs[i].x + obs[i].zasieg) div 5,
        (obs[i].y + obs[i].zasieg) div 5);
    end;
  image.Canvas.Pen.Color:=clCream;
  for i:=0 to Length(lod)-1 do
    begin
      image.Canvas.Pixels[lod[i].x div 5,lod[i].y div 5]:=clCream;
      image.Canvas.Pixels[lod[i].x div 5 - 1,lod[i].y div 5 - 1]:=clCream;
      image.Canvas.Pixels[lod[i].x div 5 - 1,lod[i].y div 5 + 1]:=clCream;
      image.Canvas.Pixels[lod[i].x div 5 + 1,lod[i].y div 5 - 1]:=clCream;
      image.Canvas.Pixels[lod[i].x div 5 + 1,lod[i].y div 5 + 1]:=clCream;
      image.Canvas.Ellipse(
        (lod[i].x - lod[i].zasieg) div 5,
        (lod[i].y - lod[i].zasieg) div 5,
        (lod[i].x + lod[i].zasieg) div 5,
        (lod[i].y + lod[i].zasieg) div 5);
    end;
  for i:=0 to Length(rek)-1 do if not rek[i].killed then
    begin
      image.Canvas.Pen.Color:=RGB(255,128,0);
      p.Left:=(rek[i].x div 5)-1;
      p.Top:=(rek[i].y div 5)-1;
      p.Right:=(rek[i].x div 5)+2;
      p.Bottom:=(rek[i].y div 5)+2;
      image.Canvas.Rectangle(p);
{      image.Canvas.Pixels[rek[i].x div 5,rek[i].y div 5]:=clYellow;
      image.Canvas.Pixels[rek[i].x div 5 - 1,rek[i].y div 5 - 1]:=clYellow;
      image.Canvas.Pixels[rek[i].x div 5 - 1,rek[i].y div 5 + 1]:=clYellow;
      image.Canvas.Pixels[rek[i].x div 5 + 1,rek[i].y div 5 - 1]:=clYellow;
      image.Canvas.Pixels[rek[i].x div 5 + 1,rek[i].y div 5 + 1]:=clYellow;}
    end;
  for i:=0 to Length(czl)-1 do if not czl[i].killed then
    begin
      image.Canvas.Pen.Color:=RGB(128,0,0);
      p.Left:=(czl[i].x div 5)-1;
      p.Top:=(czl[i].y div 5)-1;
      p.Right:=(czl[i].x div 5)+2;
      p.Bottom:=(czl[i].y div 5)+2;
      image.Canvas.Rectangle(p);
{      image.Canvas.Pixels[czl[i].x div 5,czl[i].y div 5]:=RGB(128,0,0);
      image.Canvas.Pixels[czl[i].x div 5 - 1,czl[i].y div 5 - 1]:=RGB(128,0,0);
      image.Canvas.Pixels[czl[i].x div 5 - 1,czl[i].y div 5 + 1]:=RGB(128,0,0);
      image.Canvas.Pixels[czl[i].x div 5 + 1,czl[i].y div 5 - 1]:=RGB(128,0,0);
      image.Canvas.Pixels[czl[i].x div 5 + 1,czl[i].y div 5 + 1]:=RGB(128,0,0); }
    end;
  image.Canvas.Pen.Color:=clRed;
  image.Canvas.Rectangle(rect);
  Image1.Canvas.CopyRect(GetClientRect,image.Canvas,GetClientRect);
  image.Destroy;
end;

procedure TForm3.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px:=(X * 5) - Form2.ClientWidth div 2;
  py:=(Y * 5) - Form2.ClientHeight div 2;
end;

end.
